<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/include/rdc_delete_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.LineNr { color: #585858; }
.Conditional { color: #af87d7; font-weight: bold; }
.Repeat { color: #af87d7; font-weight: bold; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Macro { color: #00afaf; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
.Todo { color: #ff8700; background-color: #1c1c1c; padding-bottom: 1px; font-weight: bold; }
.Number { color: #ff5faf; }
.Boolean { color: #d7af00; font-weight: bold; }
.pliRainbow_lv0_o0 { color: #add8e6; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.Comment { color: #808080; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="Comment">/* START OF:        rdc_delete_.incl.pl1                      *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L4" class="LineNr">  4 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L5" class="LineNr">  5 </span>          <span class="Comment">/* N^H__^Ha_^Hm_^He:  rdc_delete_.incl.pl1                                                          */</span>
<span id="L6" class="LineNr">  6 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L7" class="LineNr">  7 </span>          <span class="Comment">/*      This include segment is used by compilers generated by the reduction_compiler.    */</span>
<span id="L8" class="LineNr">  8 </span>          <span class="Comment">/* It defines a procedure which the compilers can use to delete tokens from their list of */</span>
<span id="L9" class="LineNr">  9 </span>          <span class="Comment">/* input tokens.                                                                          */</span>
<span id="L10" class="LineNr"> 10 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L11" class="LineNr"> 11 </span>          <span class="Comment">/* E^H__^Hn_^Ht_^Hr_^Hy:  DELETE                                                                              */</span>
<span id="L12" class="LineNr"> 12 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L13" class="LineNr"> 13 </span>          <span class="Comment">/*      DELETE removes the input tokens identified by the starting and ending number      */</span>
<span id="L14" class="LineNr"> 14 </span>          <span class="Comment">/* arguments from the list of input tokens.                                               */</span>
<span id="L15" class="LineNr"> 15 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L16" class="LineNr"> 16 </span>          <span class="Comment">/* U^H__^Hs_^Ha_^Hg_^He                                                                                       */</span>
<span id="L17" class="LineNr"> 17 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L18" class="LineNr"> 18 </span>          <span class="Comment">/*      call DELETE (start, end);                                                         */</span>
<span id="L19" class="LineNr"> 19 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L20" class="LineNr"> 20 </span>          <span class="Comment">/* 1) start    is the number relative to the token identified by Pthis_token of the first */</span>
<span id="L21" class="LineNr"> 21 </span>          <span class="Comment">/*             token to be removed from the list. (In)                                    */</span>
<span id="L22" class="LineNr"> 22 </span>          <span class="Comment">/* 2) end      is the number relative to the token identified by Pthis_token of the last  */</span>
<span id="L23" class="LineNr"> 23 </span>          <span class="Comment">/*             token to be removed from the list. (In)                                    */</span>
<span id="L24" class="LineNr"> 24 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L25" class="LineNr"> 25 </span>          <span class="Comment">/* N^H__^Ho_^Ht_^He_^Hs                                                                                       */</span>
<span id="L26" class="LineNr"> 26 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L27" class="LineNr"> 27 </span>          <span class="Comment">/*      The token identified by Pthis_token is regarded as token number 0.  Tokens        */</span>
<span id="L28" class="LineNr"> 28 </span>          <span class="Comment">/* which precede it have negative numbers, and those which follow have positive numbers.  */</span>
<span id="L29" class="LineNr"> 29 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L30" class="LineNr"> 30 </span>          <span class="Comment">/*      If the token identified by Pthis_token is one of those which are deleted, then    */</span>
<span id="L31" class="LineNr"> 31 </span>          <span class="Comment">/* the first token in the list following those which have been deleted will be identified */</span>
<span id="L32" class="LineNr"> 32 </span>          <span class="Comment">/* by Pthis_token.  If in 'PUSH DOWN LANGUAGE' mode and there are no tokens following     */</span>
<span id="L33" class="LineNr"> 33 </span>          <span class="Comment">/* those which have been deleted, then the first token preceding those which have been    */</span>
<span id="L34" class="LineNr"> 34 </span>          <span class="Comment">/* deleted will be indentified by Pthis_token.                                            */</span>
<span id="L35" class="LineNr"> 35 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L36" class="LineNr"> 36 </span>          <span class="Comment">/*      </span><span class="Todo">Note</span><span class="Comment"> that DELETE(0,0) in 'PUSH DOWN LANGUAGE' mode has the effect of popping the  */</span>
<span id="L37" class="LineNr"> 37 </span>          <span class="Comment">/* token off the top of the stack, and pushing a new token onto the stack in its place.   */</span>
<span id="L38" class="LineNr"> 38 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L39" class="LineNr"> 39 </span>          <span class="Comment">/* S^H__^Ht_^Ha_^Ht_^Hu_^Hs                                                                                   */</span>
<span id="L40" class="LineNr"> 40 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L41" class="LineNr"> 41 </span>          <span class="Comment">/* 0) Created by:  G. C. Dixon  in  February, 1975.                                       */</span>
<span id="L42" class="LineNr"> 42 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L43" class="LineNr"> 43 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span><span class="Keyword">DELETE</span><span class="Operator">:</span>   <span class="Keyword">procedure</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Astart</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">Aend</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>     <span class="Keyword">dcl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Astart</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">Aend</span><span class="pliRainbow_lv0_p0">)</span>                 <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>     <span class="Keyword">dcl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span>                   <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>          <span class="Comment">/* copies of our input arguments.                 */</span>
<span id="L51" class="LineNr"> 51 </span>^L
<span id="L52" class="LineNr"> 52 </span>          <span class="Conditional">if</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span> <span class="Keyword">return</span><span class="Normal">;</span>                <span class="Comment">/* If input list already exhausted, cannot delete.*/</span>
<span id="L53" class="LineNr"> 53 </span>          <span class="Conditional">if</span> <span class="Normal">Astart</span> <span class="Operator">&gt;</span> <span class="Normal">Aend</span> <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>                         <span class="Comment">/* reverse input args if backwards.               */</span>
<span id="L54" class="LineNr"> 54 </span>               <span class="Normal">start</span> <span class="Operator">=</span> <span class="Normal">Aend</span><span class="Normal">;</span>
<span id="L55" class="LineNr"> 55 </span>               <span class="Keyword">end</span>   <span class="Operator">=</span> <span class="Normal">Astart</span><span class="Normal">;</span>
<span id="L56" class="LineNr"> 56 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L57" class="LineNr"> 57 </span>          <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L58" class="LineNr"> 58 </span>               <span class="Normal">start</span> <span class="Operator">=</span> <span class="Normal">Astart</span><span class="Normal">;</span>
<span id="L59" class="LineNr"> 59 </span>               <span class="Keyword">end</span>   <span class="Operator">=</span> <span class="Normal">Aend</span><span class="Normal">;</span>
<span id="L60" class="LineNr"> 60 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L61" class="LineNr"> 61 </span>          <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span><span class="Normal">;</span>                             <span class="Comment">/* make sure these pointers are the same.         */</span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>          <span class="Conditional">if</span> <span class="Normal">start</span> <span class="Operator">&gt;</span> <span class="Number">0</span> <span class="Keyword">then</span> <span class="Keyword">call</span> <span class="Normal">delete_positive</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L64" class="LineNr"> 64 </span>                                                            <span class="Comment">/* deleted tokens all follow Pthis_token.         */</span>
<span id="L65" class="LineNr"> 65 </span>          <span class="Conditional">else</span> <span class="Conditional">if</span> <span class="Keyword">end</span> <span class="Operator">&lt;</span> <span class="Number">0</span> <span class="Keyword">then</span> <span class="Keyword">call</span> <span class="Normal">delete_negative</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L66" class="LineNr"> 66 </span>                                                            <span class="Comment">/* deleted tokens all precede Pthis_token.        */</span>
<span id="L67" class="LineNr"> 67 </span>          <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>                                          <span class="Comment">/* deleted tokens include Pthis_token.            */</span>
<span id="L68" class="LineNr"> 68 </span>               <span class="Conditional">if</span> <span class="Normal">start</span> <span class="Operator">&lt;</span> <span class="Number">0</span> <span class="Keyword">then</span> <span class="Keyword">call</span> <span class="Normal">delete_negative</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Operator">-</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L69" class="LineNr"> 69 </span>                                                            <span class="Comment">/* first, delete those which precede Pthis_token. */</span>
<span id="L70" class="LineNr"> 70 </span>               <span class="Conditional">if</span> <span class="Keyword">end</span> <span class="Operator">&gt;</span> <span class="Number">0</span> <span class="Keyword">then</span> <span class="Keyword">call</span> <span class="Normal">delete_positive</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L71" class="LineNr"> 71 </span>                                                            <span class="Comment">/* then, delete those which follow Pthis_token.   */</span>
<span id="L72" class="LineNr"> 72 </span>               <span class="Conditional">if</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>                   <span class="Comment">/* if no more tokens follow Pthis_token,          */</span>
<span id="L73" class="LineNr"> 73 </span>                    <span class="Conditional">if</span> <span class="Normal">SPDL</span> <span class="Keyword">then</span>                            <span class="Comment">/*   and in 'PUSH DOWN LANGUAGE' mode,            */</span>
<span id="L74" class="LineNr"> 74 </span>                         <span class="Conditional">if</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>         <span class="Comment">/*   and no more tokens precede Pthis_token,      */</span>
<span id="L75" class="LineNr"> 75 </span>                              <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>                <span class="Comment">/*   then all tokens have been deleted.           */</span>
<span id="L76" class="LineNr"> 76 </span>                         <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L77" class="LineNr"> 77 </span>                              <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span><span class="Normal">;</span>         <span class="Comment">/*   else still tokens on stack.  2nd top of stack*/</span>
<span id="L78" class="LineNr"> 78 </span>                              <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>           <span class="Comment">/*   becomes top, and old top is deleted.         */</span>
<span id="L79" class="LineNr"> 79 </span>                              <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L80" class="LineNr"> 80 </span>                    <span class="Conditional">else</span> <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>                     <span class="Comment">/*   not in 'PUSH DOWN LANGUAGE' mode; remaining  */</span>
<span id="L81" class="LineNr"> 81 </span>                                                            <span class="Comment">/*   tokens have been deleted.                    */</span>
<span id="L82" class="LineNr"> 82 </span>               <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>                                     <span class="Comment">/* if there is a following token, make it be      */</span>
<span id="L83" class="LineNr"> 83 </span>                    <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span><span class="Normal">;</span>                   <span class="Comment">/*   identified by Pthis_token, and delete the    */</span>
<span id="L84" class="LineNr"> 84 </span>                    <span class="Keyword">call</span> <span class="Normal">delete_negative</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">-</span><span class="Number">1</span><span class="pliRainbow_lv0_o0">,</span> <span class="Operator">-</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>          <span class="Comment">/*   old Pthis_token.                             */</span>
<span id="L85" class="LineNr"> 85 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L86" class="LineNr"> 86 </span>               <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span><span class="Normal">;</span>
<span id="L87" class="LineNr"> 87 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L88" class="LineNr"> 88 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span><span class="Normal">delete_positive</span><span class="Operator">:</span>    <span class="Keyword">procedure</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>                 <span class="Comment">/* This entry deletes tokens following Pthis_token*/</span>
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L94" class="LineNr"> 94 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L95" class="LineNr"> 95 </span>          <span class="Comment">/* The procedure below handles deletion of tokens which precede and follow Pthis_token    */</span>
<span id="L96" class="LineNr"> 96 </span>          <span class="Comment">/* in the same way by mapping the starting and ending token numbers into an inner and     */</span>
<span id="L97" class="LineNr"> 97 </span>          <span class="Comment">/* outer token number, as shown below.                                                    */</span>
<span id="L98" class="LineNr"> 98 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L99" class="LineNr"> 99 </span>          <span class="Comment">/*        N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ -&gt; N^HZ    */</span>
<span id="L100" class="LineNr">100 </span>          <span class="Comment">/*                                           A^H|                                         */</span>
<span id="L101" class="LineNr">101 </span>          <span class="Comment">/*                                           |                                            */</span>
<span id="L102" class="LineNr">102 </span>          <span class="Comment">/*             A^H|              A^H|         Pthis_token    A^H|                        A^H|       */</span>
<span id="L103" class="LineNr">103 </span>          <span class="Comment">/*             |              |                        |                        |         */</span>
<span id="L104" class="LineNr">104 </span>          <span class="Comment">/*           start           end                     start                     end        */</span>
<span id="L105" class="LineNr">105 </span>          <span class="Comment">/*           outer          inner                    inner                    outer       */</span>
<span id="L106" class="LineNr">106 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L107" class="LineNr">107 </span>          <span class="Comment">/* This mapping allows preceding and following tokens to be deleted in the same way.      */</span>
<span id="L108" class="LineNr">108 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L109" class="LineNr">109 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>     <span class="Keyword">dcl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span>                   <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>
<span id="L113" class="LineNr">113 </span>
<span id="L114" class="LineNr">114 </span>     <span class="Keyword">dcl</span>  <span class="Number">1</span> <span class="Normal">token</span>                       <span class="Macro">based</span><span class="Normal">,</span>              <span class="Comment">/* overlay for token converting token.Pnext/last  */</span>
<span id="L115" class="LineNr">115 </span>            <span class="Number">2</span> <span class="Normal">pad</span>                       <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/*   to a 2-element pointer array.                */</span>
<span id="L116" class="LineNr">116 </span>            <span class="Number">2</span> <span class="Keyword">P</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="Operator">:</span><span class="Number">2</span><span class="pliRainbow_lv0_p0">)</span>                   <span class="Macro">ptr</span> <span class="Macro">unaligned</span><span class="Normal">,</span>
<span id="L117" class="LineNr">117 </span>         <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Pinner</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">Pouter</span><span class="pliRainbow_lv0_p0">)</span>               <span class="Macro">ptr</span><span class="Normal">,</span>                <span class="Comment">/* pointers to inner/outer tokens.                */</span>
<span id="L118" class="LineNr">118 </span>         <span class="pliRainbow_lv0_p0">(</span> <span class="Normal">inner</span><span class="pliRainbow_lv0_o0">,</span>  <span class="Normal">outer</span><span class="pliRainbow_lv0_p0">)</span>               <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/* #s of inner/outer tokens (wrt Pthis_token)     */</span>
<span id="L119" class="LineNr">119 </span>         <span class="pliRainbow_lv0_p0">(</span>    <span class="Keyword">in</span><span class="pliRainbow_lv0_o0">,</span>  <span class="Normal">out</span>  <span class="pliRainbow_lv0_p0">)</span>               <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/* elements of token.P for next inner/outer token */</span>
<span id="L120" class="LineNr">120 </span>          <span class="Normal">direction</span>                     <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/* increment added to inner # to reach outer #.   */</span>
<span id="L121" class="LineNr">121 </span>          <span class="Normal">i</span>                             <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>          <span class="Comment">/* a do-group index.                              */</span>
<span id="L122" class="LineNr">122 </span>          <span class="Normal">inner</span> <span class="Operator">=</span> <span class="Normal">start</span><span class="Normal">;</span>      <span class="Normal">outer</span> <span class="Operator">=</span> <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L123" class="LineNr">123 </span>             <span class="Keyword">in</span> <span class="Operator">=</span> <span class="Number">2</span><span class="Normal">;</span>            <span class="Normal">out</span> <span class="Operator">=</span> <span class="Number">1</span><span class="Normal">;</span>
<span id="L124" class="LineNr">124 </span>                    <span class="Normal">direction</span> <span class="Operator">=</span> <span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>          <span class="Keyword">go</span> <span class="Keyword">to</span> <span class="Normal">common</span><span class="Normal">;</span>
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span><span class="Normal">delete_negative</span><span class="Operator">:</span>    <span class="Keyword">entry</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">start</span><span class="pliRainbow_lv0_o0">,</span> <span class="Keyword">end</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>                     <span class="Comment">/* This entry deletes tokens preceding Pthis_token*/</span>
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>          <span class="Normal">inner</span> <span class="Operator">=</span> <span class="Keyword">end</span><span class="Normal">;</span>        <span class="Normal">outer</span> <span class="Operator">=</span> <span class="Normal">start</span><span class="Normal">;</span>
<span id="L131" class="LineNr">131 </span>             <span class="Keyword">in</span> <span class="Operator">=</span> <span class="Number">1</span><span class="Normal">;</span>            <span class="Normal">out</span> <span class="Operator">=</span> <span class="Number">2</span><span class="Normal">;</span>
<span id="L132" class="LineNr">132 </span>                    <span class="Normal">direction</span> <span class="Operator">=</span> <span class="Operator">-</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span><span class="Normal">common</span><span class="Operator">:</span>   <span class="Normal">Pinner</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span><span class="Normal">;</span>                                  <span class="Comment">/* start at Pthis_token.                          */</span>
<span id="L135" class="LineNr">135 </span>          <span class="Keyword">do</span> <span class="Normal">i</span> <span class="Operator">=</span> <span class="Normal">direction</span> <span class="Keyword">to</span> <span class="Normal">inner</span> <span class="Keyword">by</span> <span class="Normal">direction</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Pinner</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L136" class="LineNr">136 </span>               <span class="Normal">Pinner</span> <span class="Operator">=</span> <span class="Normal">Pinner</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>             <span class="Comment">/* work out from Pthis_token until inner token is */</span>
<span id="L137" class="LineNr">137 </span>               <span class="Keyword">end</span><span class="Normal">;</span>                                         <span class="Comment">/*   found.                                       */</span>
<span id="L138" class="LineNr">138 </span>          <span class="Conditional">if</span> <span class="Normal">Pinner</span> <span class="Operator">^=</span> <span class="Boolean">null</span> <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>                        <span class="Comment">/* if inner token doesn't exist, nothing to delete*/</span>
<span id="L139" class="LineNr">139 </span>               <span class="Normal">Pouter</span> <span class="Operator">=</span> <span class="Normal">Pinner</span><span class="Normal">;</span>                             <span class="Comment">/* starting at inner token, work out to outer one.*/</span>
<span id="L140" class="LineNr">140 </span>               <span class="Keyword">do</span> <span class="Normal">i</span> <span class="Operator">=</span> <span class="Normal">inner</span><span class="Operator">+</span><span class="Normal">direction</span> <span class="Keyword">to</span> <span class="Normal">outer</span> <span class="Keyword">by</span> <span class="Normal">direction</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Pouter</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L141" class="LineNr">141 </span>                    <span class="Normal">Pouter</span> <span class="Operator">=</span> <span class="Normal">Pouter</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L142" class="LineNr">142 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L143" class="LineNr">143 </span>               <span class="Conditional">if</span> <span class="Normal">Pouter</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>                        <span class="Comment">/* if outer token not found, delete all tokens    */</span>
<span id="L144" class="LineNr">144 </span>                                                            <span class="Comment">/*   from inner one to outer-most.                */</span>
<span id="L145" class="LineNr">145 </span>                    <span class="Normal">Pinner</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Keyword">in</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>
<span id="L146" class="LineNr">146 </span>               <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>                                     <span class="Comment">/* otherwise, delete inner to outer token.        */</span>
<span id="L147" class="LineNr">147 </span>                    <span class="Normal">Pinner</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Keyword">in</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">Pouter</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L148" class="LineNr">148 </span>                    <span class="Conditional">if</span> <span class="Normal">Pouter</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">^=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>
<span id="L149" class="LineNr">149 </span>                         <span class="Normal">Pouter</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">out</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Keyword">in</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">Pinner</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Keyword">P</span><span class="pliRainbow_lv0_p0">(</span><span class="Keyword">in</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L150" class="LineNr">150 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L151" class="LineNr">151 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>          <span class="Keyword">end</span> <span class="Normal">delete_positive</span><span class="Normal">;</span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>          <span class="Keyword">end</span> <span class="Keyword">DELETE</span><span class="Normal">;</span>
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span><span class="Comment">/* END OF:          rdc_delete_.incl.pl1                      *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
